# coding: utf-8


"""
IGNORE:
    Nutanix AIOps APIs

    Manage infrastructure on-premises and in the cloud seamlessly through AIOps features such as Analysis, Reporting, Capacity Planning, What if Analysis, VM Rightsizing, Troubleshooting, App Discovery, Broad Observability, and Ops Automation through Playbooks.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_aiops_py_client.models.aiops.v4.clusterMetrics.Node import Node  # noqa: F401,E501

class NodeProjection(Node):

    """

    :param node_uuid: (:attr:`node_uuid`) 
    :type node_uuid: 
    
    
    :param ha_memory_reserved_bytes: (:attr:`ha_memory_reserved_bytes`) 
    :type ha_memory_reserved_bytes: 
    
    
    :param num_cpu_threads: (:attr:`num_cpu_threads`) 
    :type num_cpu_threads: 
    
    
    :param capacity_hz: (:attr:`capacity_hz`) 
    :type capacity_hz: 
    
    
    :param memory_size_bytes: (:attr:`memory_size_bytes`) 
    :type memory_size_bytes: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'node_uuid': 'str',
        'ha_memory_reserved_bytes': 'str',
        'num_cpu_threads': 'str',
        'capacity_hz': 'str',
        'memory_size_bytes': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'node_uuid': 'nodeUuid',
        'ha_memory_reserved_bytes': 'haMemoryReservedBytes',
        'num_cpu_threads': 'numCpuThreads',
        'capacity_hz': 'capacityHz',
        'memory_size_bytes': 'memorySizeBytes',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, node_uuid=None, ha_memory_reserved_bytes=None, num_cpu_threads=None, capacity_hz=None, memory_size_bytes=None, *args, **kwargs):  # noqa: E501
        Node.__init__(self, node_uuid, ha_memory_reserved_bytes, num_cpu_threads, capacity_hz, memory_size_bytes, *args, **kwargs)
        self.discriminator = None

    def _initialize_object_type(self):
        return 'aiops.v4.clusterMetrics.NodeProjection'

    def _initialize_object_version(self):
        return 'v4.r0'


    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(NodeProjection, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NodeProjection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

