# coding: utf-8


"""
IGNORE:
    Nutanix AIOps APIs

    Manage infrastructure on-premises and in the cloud seamlessly through AIOps features such as Analysis, Reporting, Capacity Planning, What if Analysis, VM Rightsizing, Troubleshooting, App Discovery, Broad Observability, and Ops Automation through Playbooks.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path

class Runway(object):

    """Runway in a scenario.

    :param minimum_runway_days: (:attr:`minimum_runway_days`) Number of days the cluster will be able to sustain the existing and added workloads.
    :type minimum_runway_days: required
    
     min=0, max=366
    :param cpu_runway_days: (:attr:`cpu_runway_days`) Number of days the CPU can sustain the added and existing workload.
    :type cpu_runway_days: required
    
     min=0, max=366
    :param memory_runway_days: (:attr:`memory_runway_days`) Number of days the memory can sustain the added and existing workload.
    :type memory_runway_days: required
    
     min=0, max=366
    :param storage_runway_days: (:attr:`storage_runway_days`) Number of days the storage can sustain the added and existing workload.
    :type storage_runway_days: required
    
     min=0, max=366
    :param runway_start_date: (:attr:`runway_start_date`) The starting date of the usage, capacity, and effective capacity forecasts. It is used as the start-time in stats API to query scenario statistics.
    :type runway_start_date: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'minimum_runway_days': 'int',
        'cpu_runway_days': 'int',
        'memory_runway_days': 'int',
        'storage_runway_days': 'int',
        'runway_start_date': 'date',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'minimum_runway_days': 'minimumRunwayDays',
        'cpu_runway_days': 'cpuRunwayDays',
        'memory_runway_days': 'memoryRunwayDays',
        'storage_runway_days': 'storageRunwayDays',
        'runway_start_date': 'runwayStartDate',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, minimum_runway_days=None, cpu_runway_days=None, memory_runway_days=None, storage_runway_days=None, runway_start_date=None, *args, **kwargs):  # noqa: E501
        self.__minimum_runway_days = None
        self.__cpu_runway_days = None
        self.__memory_runway_days = None
        self.__storage_runway_days = None
        self.__runway_start_date = None
        self.discriminator = None
        self.__minimum_runway_days = minimum_runway_days
        self.__cpu_runway_days = cpu_runway_days
        self.__memory_runway_days = memory_runway_days
        self.__storage_runway_days = storage_runway_days
        if runway_start_date is not None:
            self.__runway_start_date = runway_start_date
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'aiops.v4.config.Runway'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def minimum_runway_days(self):
        """
        Number of days the cluster will be able to sustain the existing and added workloads.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__minimum_runway_days

    @minimum_runway_days.setter
    def minimum_runway_days(self, minimum_runway_days):
        if minimum_runway_days is None:
            raise ValueError("Invalid value for `minimum_runway_days`, must not be `None`")  # noqa: E501
        if minimum_runway_days is not None and minimum_runway_days > 366:  # noqa: E501
            raise ValueError("Invalid value for `minimum_runway_days`, must be a value less than or equal to `366`")  # noqa: E501
        if minimum_runway_days is not None and minimum_runway_days < 0:  # noqa: E501
            raise ValueError("Invalid value for `minimum_runway_days`, must be a value greater than or equal to `0`")  # noqa: E501

        self.__minimum_runway_days = minimum_runway_days

    @property
    def cpu_runway_days(self):
        """
        Number of days the CPU can sustain the added and existing workload.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__cpu_runway_days

    @cpu_runway_days.setter
    def cpu_runway_days(self, cpu_runway_days):
        if cpu_runway_days is None:
            raise ValueError("Invalid value for `cpu_runway_days`, must not be `None`")  # noqa: E501
        if cpu_runway_days is not None and cpu_runway_days > 366:  # noqa: E501
            raise ValueError("Invalid value for `cpu_runway_days`, must be a value less than or equal to `366`")  # noqa: E501
        if cpu_runway_days is not None and cpu_runway_days < 0:  # noqa: E501
            raise ValueError("Invalid value for `cpu_runway_days`, must be a value greater than or equal to `0`")  # noqa: E501

        self.__cpu_runway_days = cpu_runway_days

    @property
    def memory_runway_days(self):
        """
        Number of days the memory can sustain the added and existing workload.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__memory_runway_days

    @memory_runway_days.setter
    def memory_runway_days(self, memory_runway_days):
        if memory_runway_days is None:
            raise ValueError("Invalid value for `memory_runway_days`, must not be `None`")  # noqa: E501
        if memory_runway_days is not None and memory_runway_days > 366:  # noqa: E501
            raise ValueError("Invalid value for `memory_runway_days`, must be a value less than or equal to `366`")  # noqa: E501
        if memory_runway_days is not None and memory_runway_days < 0:  # noqa: E501
            raise ValueError("Invalid value for `memory_runway_days`, must be a value greater than or equal to `0`")  # noqa: E501

        self.__memory_runway_days = memory_runway_days

    @property
    def storage_runway_days(self):
        """
        Number of days the storage can sustain the added and existing workload.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__storage_runway_days

    @storage_runway_days.setter
    def storage_runway_days(self, storage_runway_days):
        if storage_runway_days is None:
            raise ValueError("Invalid value for `storage_runway_days`, must not be `None`")  # noqa: E501
        if storage_runway_days is not None and storage_runway_days > 366:  # noqa: E501
            raise ValueError("Invalid value for `storage_runway_days`, must be a value less than or equal to `366`")  # noqa: E501
        if storage_runway_days is not None and storage_runway_days < 0:  # noqa: E501
            raise ValueError("Invalid value for `storage_runway_days`, must be a value greater than or equal to `0`")  # noqa: E501

        self.__storage_runway_days = storage_runway_days

    @property
    def runway_start_date(self):
        """
        The starting date of the usage, capacity, and effective capacity forecasts. It is used as the start-time in stats API to query scenario statistics.

        :type:
                :class:`~date`
        """  # noqa: E501
        return self.__runway_start_date

    @runway_start_date.setter
    def runway_start_date(self, runway_start_date):

        self.__runway_start_date = runway_start_date

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(Runway, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Runway):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

