# coding: utf-8


"""
IGNORE:
    Nutanix AIOps APIs

    Manage infrastructure on-premises and in the cloud seamlessly through AIOps features such as Analysis, Reporting, Capacity Planning, What if Analysis, VM Rightsizing, Troubleshooting, App Discovery, Broad Observability, and Ops Automation through Playbooks.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_aiops_py_client.models.aiops.v4.config.SimulatedVmResourceSpec import SimulatedVmResourceSpec  # noqa: F401,E501

class SimulatedVmResourceSpecProjection(SimulatedVmResourceSpec):

    """

    :param vcpu_count: (:attr:`vcpu_count`) Number of vCPUs.
    :type vcpu_count: required
    
    
    :param ram_gb: (:attr:`ram_gb`) RAM capacity in GB.
    :type ram_gb: required
    
    
    :param hdd_gb: (:attr:`hdd_gb`) HDD capacity in GB.
    :type hdd_gb: required
    
    
    :param ssd_gb: (:attr:`ssd_gb`) SSD capacity in GB.
    :type ssd_gb: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'vcpu_count': 'int',
        'ram_gb': 'float',
        'hdd_gb': 'float',
        'ssd_gb': 'float',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'vcpu_count': 'vcpuCount',
        'ram_gb': 'ramGb',
        'hdd_gb': 'hddGb',
        'ssd_gb': 'ssdGb',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, vcpu_count=None, ram_gb=None, hdd_gb=None, ssd_gb=None, *args, **kwargs):  # noqa: E501
        SimulatedVmResourceSpec.__init__(self, vcpu_count, ram_gb, hdd_gb, ssd_gb, *args, **kwargs)
        self.discriminator = None

    def _initialize_object_type(self):
        return 'aiops.v4.config.SimulatedVmResourceSpecProjection'

    def _initialize_object_version(self):
        return 'v4.r0'


    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(SimulatedVmResourceSpecProjection, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SimulatedVmResourceSpecProjection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

