# coding: utf-8


"""
IGNORE:
    Nutanix AIOps APIs

    Manage infrastructure on-premises and in the cloud seamlessly through AIOps features such as Analysis, Reporting, Capacity Planning, What if Analysis, VM Rightsizing, Troubleshooting, App Discovery, Broad Observability, and Ops Automation through Playbooks.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_aiops_py_client.models.aiops.v4.config.SqlProfileType import SqlProfileType  # noqa: F401,E501
from ntnx_aiops_py_client.models.aiops.v4.config.SqlTransactionType import SqlTransactionType  # noqa: F401,E501

class SqlWorkload(object):

    """SQL workload description.

    :param db_count: (:attr:`db_count`) Number of SQL instances.
    :type db_count: required
    
     min=1, max=100000
    :param profile_type: (:attr:`profile_type`) 
    :type profile_type: required
    
    
    :param transaction_type: (:attr:`transaction_type`) 
    :type transaction_type: required
    
    
    :param is_business_critical: (:attr:`is_business_critical`) Whether the SQL instance is critical to business or not. (**Default** False)
    :type is_business_critical: required
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'db_count': 'int',
        'profile_type': 'aiops.v4.config.SqlProfileType',
        'transaction_type': 'aiops.v4.config.SqlTransactionType',
        'is_business_critical': 'bool',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'db_count': 'dbCount',
        'profile_type': 'profileType',
        'transaction_type': 'transactionType',
        'is_business_critical': 'isBusinessCritical',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, db_count=None, profile_type=None, transaction_type=None, is_business_critical=False, *args, **kwargs):  # noqa: E501
        self.__db_count = None
        self.__profile_type = None
        self.__transaction_type = None
        self.__is_business_critical = None
        self.discriminator = None
        self.__db_count = db_count
        self.__profile_type = profile_type
        self.__transaction_type = transaction_type
        self.__is_business_critical = is_business_critical
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'aiops.v4.config.SqlWorkload'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def db_count(self):
        """
        Number of SQL instances.

        :type:
                :class:`~int`
        """  # noqa: E501
        return self.__db_count

    @db_count.setter
    def db_count(self, db_count):
        if db_count is None:
            raise ValueError("Invalid value for `db_count`, must not be `None`")  # noqa: E501
        if db_count is not None and db_count > 100000:  # noqa: E501
            raise ValueError("Invalid value for `db_count`, must be a value less than or equal to `100000`")  # noqa: E501
        if db_count is not None and db_count < 1:  # noqa: E501
            raise ValueError("Invalid value for `db_count`, must be a value greater than or equal to `1`")  # noqa: E501

        self.__db_count = db_count

    @property
    def profile_type(self):
        """
        

        :type:
            :class:`~ntnx_aiops_py_client.models.aiops.v4.config.SqlProfileType`
        """  # noqa: E501
        return self.__profile_type

    @profile_type.setter
    def profile_type(self, profile_type):
        if profile_type is None:
            raise ValueError("Invalid value for `profile_type`, must not be `None`")  # noqa: E501

        self.__profile_type = profile_type

    @property
    def transaction_type(self):
        """
        

        :type:
            :class:`~ntnx_aiops_py_client.models.aiops.v4.config.SqlTransactionType`
        """  # noqa: E501
        return self.__transaction_type

    @transaction_type.setter
    def transaction_type(self, transaction_type):
        if transaction_type is None:
            raise ValueError("Invalid value for `transaction_type`, must not be `None`")  # noqa: E501

        self.__transaction_type = transaction_type

    @property
    def is_business_critical(self):
        """
        Whether the SQL instance is critical to business or not.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_business_critical

    @is_business_critical.setter
    def is_business_critical(self, is_business_critical):
        if is_business_critical is None:
            raise ValueError("Invalid value for `is_business_critical`, must not be `None`")  # noqa: E501

        self.__is_business_critical = is_business_critical

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(SqlWorkload, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SqlWorkload):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

